/* jshint esversion: 6 */
// ------------------------------------------------------

/* eslint-disable */
const _test = require('lamed_test')
const { notEqual, Equal, Ok, notOk, _log, _logT, _logLine, _logGreen, _logBold, _logRed,
  _ifTrace, _Trace_Set, _Trace_Get,
  _Trace, _TraceLine, _TraceGreen, _TraceBold, _Trace_Table, _Trace_Heading } = _test
/* eslint-enable */
// _Trace_Set(0)
_Trace('Starting vscode.js...')

const _lio = require('lamed_io')
const _cmd1 = require('node-run-cmd') // npm i node-run-cmd --save
// const _opn = require('opn') // npm i opn -s
const _lfolder = require('lamed_folder')

const _os = require('os')
let username = _os.userInfo().username
const _msCode = 'code64_' + username + '.bat'
const _msPath = _lfolder.rootFolder()
const _codeEditor = _msPath + _msCode // Path to mscode editor bat file

/**
 *  MS code.exe setup
 *  - "C:\Program Files\Microsoft VS Code\Code.exe" "%*"
 *  - "C:\Users\USERNAME\AppData\Local\Programs\Microsoft VS Code\Code.exe" "%*"
 */
async function vscodeSetup () {
  if (vscodeOk() === false) {
    _logLine()
    _logRed(`Error: File "${_codeEditor}" does not exist!`)
    let path1 = 'C:\\Program Files\\Microsoft VS Code\\Code.exe'
    let path2 = `C:\\Users\\${username}\\AppData\\Local\\Programs\\Microsoft VS Code\\Code.exe`
    let cmd1 = '"C:\\Program Files\\Microsoft VS Code\\Code.exe" "%*"'
    let cmd2 = `"C:\\Users\\${username}\\AppData\\Local\\Programs\\Microsoft VS Code\\Code.exe" "%*"`

    if (_lio.exist(path1)) await _lio.writeFile(_codeEditor, cmd1)
    else if (_lio.exist(path2)) await _lio.writeFile(_codeEditor, cmd2)
    else throw new Error('Unable to find mscode editor!')

    _logLine()
    _logGreen(`Batch file "${_codeEditor}" was setup!`)
    _logLine()
  }
}
vscodeSetup() // Setup mscode .bat file

/**
 * Check if code editor was setup
 */
function vscodeOk (showError = false) {
  let result = _lio.exist(_codeEditor)
  if (showError && result === false) throw new Error(`mscode setup file missing: "${_codeEditor}"`)
  return result
}

/**
 * Returns the path the mscode
 */
function vscodePath () {
  return _codeEditor
}

/**
 * Return command to open mscode for editfile
 * @param {string} editFile - The file to edit
 */
function vscodeOpenCommand (editFile) {
  if (vscodeOk() === false) throw new Error(`MS Code editor is not setup in "${_codeEditor}"`)

  if (_lio.exist(editFile) === false) {
    _logRed(`'${editFile}' does not exists.`)
    throw new Error(`'${editFile}' does not exists.`)
  }

  let cmd = _codeEditor + ' "' + editFile + '"'
  return cmd
}

/**
 * Open mscode for editfile
 * @param {string} editFile - The file to open in mscode
 */
function vscodeOpen (editFile) {
  let cmd = vscodeOpenCommand(editFile)
  _cmd1.run(cmd, showError)
    .catch((err) => {
      _Trace({ err })
    })
}

/**
 * show error message in red
 * @param {string} error - the error to show
 */
function showError (error) {
  _log()
  _logLine()
  _logRed('Catch -> ' + error)
  _logLine()
  console.error(error.stack)
}

// Exports --------------------------
module.exports = { vscodeOk, vscodePath, vscodeOpenCommand, vscodeOpen, vscodeSetup }
