console.log('Starting vscode.test.js...')
/* jshint esversion: 6 */
// ------------------------------------------------------

/* eslint-disable */
const _test = require('lamed_test')
const { notEqual, Equal, Ok, notOk, _log, _logT, _logLine, _logGreen, _logBold, _logRed,
  _ifTrace, _Trace_Set, _Trace_Get,
  _Trace, _TraceLine, _TraceBold, _Trace_Table, _Trace_Heading } = _test
/* eslint-enable */

const _app = require('../src/vscode')

async function vscodeTest (done) { // eslint-disable-line
  _TraceLine()
  _Trace(module.filename)
  _TraceBold(`--------------------------> ${arguments.callee.name}()`) // eslint-disable-line
  let error = `In ${module.filename} --> ${arguments.callee.name}()` // eslint-disable-line

  // test setup
  await _app.vscodeSetup()
  if (_app.vscodeOk(true) === false) return done(new Error(error))

  let file = _app.vscodePath()
  let cmd = _app.vscodeOpenCommand(file)
  _Trace(cmd)

  return true // success
}

/**
 * Test all functions
 * @param done - callback function to indicate failure or completion
 * @constructor
 */
async function TestAll (done) {
  _TraceLine()
  _Trace(module.filename)
  _TraceBold(`--------------------------> ${arguments.callee.name}()`) // eslint-disable-line

  vscodeTest(done)
  return true
}

/**
 * Execute the tests manually
 */
function testRunner (traceLevel = 0) {
  let isRoot = _test.isRootFolder() // const _lio = require('lamed_io')
  _Trace({ isRoot })
  if (isRoot) return

  _Trace_Set(traceLevel)
  const done2 = (err) => {
    if (err !== undefined) { throw err }
  }
  TestAll(done2) // Only run if not executed from the root folder
  _logGreen('Success!!!')
}
testRunner(0)

// Exports --------------------------
module.exports = { TestAll }
